Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/DeploymentService.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/DeploymentService.cs	(revision 2814)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/DeploymentService.cs	(revision 2860)
@@ -22,5 +22,7 @@
         private System.Runtime.Serialization.ExtensionDataObject extensionDataField;
         
-        private string ContactInformationField;
+        private string ContactEmailField;
+        
+        private string ContactNameField;
         
         private HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.PluginDescription[] DependenciesField;
@@ -45,13 +47,26 @@
         
         [System.Runtime.Serialization.DataMemberAttribute()]
-        public string ContactInformation
-        {
-            get
-            {
-                return this.ContactInformationField;
-            }
-            set
-            {
-                this.ContactInformationField = value;
+        public string ContactEmail
+        {
+            get
+            {
+                return this.ContactEmailField;
+            }
+            set
+            {
+                this.ContactEmailField = value;
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string ContactName
+        {
+            get
+            {
+                return this.ContactNameField;
+            }
+            set
+            {
+                this.ContactNameField = value;
             }
         }
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/PluginDescription.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/PluginDescription.cs	(revision 2814)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/PluginDescription.cs	(revision 2860)
@@ -31,17 +31,36 @@
 namespace HeuristicLab.PluginInfrastructure.Advanced.DeploymentService {
   // extension of auto-generated DataContract class PluginDescription
-  public partial class PluginDescription {
+  public partial class PluginDescription : IPluginDescription {
     public PluginDescription(string name, Version version) : this(name, version, new List<PluginDescription>()) { }
     public PluginDescription(string name, Version version, IEnumerable<PluginDescription> dependencies)
-      : this(name, version, dependencies, string.Empty, string.Empty) {
+      : this(name, version, dependencies, string.Empty, string.Empty, string.Empty) {
     }
 
-    public PluginDescription(string name, Version version, IEnumerable<PluginDescription> dependencies, string contactInformation, string licenseText) {
+    public PluginDescription(string name, Version version, IEnumerable<PluginDescription> dependencies, string contactName, string contactEmail, string licenseText) {
       this.Name = name;
       this.Version = version;
       this.Dependencies = dependencies.ToArray();
-      this.ContactInformation = contactInformation;
       this.LicenseText = licenseText;
     }
+
+    #region IPluginDescription Members
+
+
+    [Obsolete]
+    public DateTime BuildDate {
+      get { throw new NotImplementedException(); }
+    }
+
+    IEnumerable<IPluginDescription> IPluginDescription.Dependencies {
+      get {
+        return Dependencies;
+      }
+    }
+
+    public IEnumerable<IPluginFile> Files {
+      get { return Enumerable.Empty<IPluginFile>(); }
+    }
+
+    #endregion
   }
 }
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/ProductDescription.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/ProductDescription.cs	(revision 2814)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/ProductDescription.cs	(revision 2860)
@@ -31,5 +31,5 @@
 namespace HeuristicLab.PluginInfrastructure.Advanced.DeploymentService {
   // extension of auto-generated DataContract class ProductDescription
-  public partial class ProductDescription {
+  public partial class ProductDescription  {
     public ProductDescription(string name, Version version)
       : this(name, version, new List<PluginDescription>()) {