Index: trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 2864)
+++ trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 2865)
@@ -52,8 +52,10 @@
     <None Include="HeuristicLabOptimizationPlugin.cs.frame" />
     <Compile Include="Algorithm.cs" />
+    <Compile Include="Interfaces\IMultiObjectiveProblem.cs" />
+    <Compile Include="Interfaces\IMultiObjectiveEvaluator.cs" />
     <Compile Include="Interfaces\IAlgorithm.cs" />
-    <Compile Include="Interfaces\ICrossoverOperator.cs" />
+    <Compile Include="Interfaces\ICrossover.cs" />
     <Compile Include="Interfaces\IEvaluator.cs" />
-    <Compile Include="Interfaces\IManipulationOperator.cs" />
+    <Compile Include="Interfaces\IManipulator.cs" />
     <Compile Include="Interfaces\IProblem.cs" />
     <Compile Include="Interfaces\ISingleObjectiveEvaluator.cs" />
@@ -61,10 +63,7 @@
     <Compile Include="Interfaces\ISolutionCreator.cs" />
     <Compile Include="Interfaces\IStochasticOperator.cs" />
-    <Compile Include="SingleObjectiveProblem.cs" />
-    <Compile Include="SingleObjectiveEvaluator.cs" />
     <Compile Include="UserDefinedAlgorithm.cs" />
     <Compile Include="EngineAlgorithm.cs" />
     <Compile Include="HeuristicLabOptimizationPlugin.cs" />
-    <Compile Include="Problem.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ICrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ICrossover.cs	(revision 2865)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ICrossover.cs	(revision 2865)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization {
+  /// <summary>
+  /// An interface which represents an operator for crossing solutions.
+  /// </summary>
+  public interface ICrossover : IOperator { }
+}
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ICrossoverOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ICrossoverOperator.cs	(revision 2864)
+++ 	(revision )
@@ -1,30 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Optimization {
-  /// <summary>
-  /// An interface which represents an operator for crossing solutions.
-  /// </summary>
-  public interface ICrossoverOperator : IOperator { }
-}
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IEvaluator.cs	(revision 2864)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IEvaluator.cs	(revision 2865)
@@ -21,5 +21,4 @@
 
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Optimization {
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IManipulationOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IManipulationOperator.cs	(revision 2864)
+++ 	(revision )
@@ -1,30 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Optimization {
-  /// <summary>
-  /// An interface which represents an operator for manipulating solutions.
-  /// </summary>
-  public interface IManipulationOperator : IOperator { }
-}
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IManipulator.cs	(revision 2865)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IManipulator.cs	(revision 2865)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization {
+  /// <summary>
+  /// An interface which represents an operator for manipulating solutions.
+  /// </summary>
+  public interface IManipulator : IOperator { }
+}
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IProblem.cs	(revision 2864)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IProblem.cs	(revision 2865)
@@ -20,7 +20,6 @@
 #endregion
 
+using System;
 using HeuristicLab.Core;
-using System;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Optimization {
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ISingleObjectiveProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ISingleObjectiveProblem.cs	(revision 2864)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ISingleObjectiveProblem.cs	(revision 2865)
@@ -20,7 +20,6 @@
 #endregion
 
-using HeuristicLab.Core;
+using System;
 using HeuristicLab.Data;
-using System;
 
 namespace HeuristicLab.Optimization {
@@ -29,6 +28,6 @@
   /// </summary>
   public interface ISingleObjectiveProblem : IProblem {
-    BoolData Maximization { get; set; }
-    new ISingleObjectiveEvaluator Evaluator { get; set; }
+    BoolData Maximization { get; }
+    new ISingleObjectiveEvaluator Evaluator { get; }
 
     event EventHandler MaximizationChanged;
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ISolutionCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ISolutionCreator.cs	(revision 2864)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/ISolutionCreator.cs	(revision 2865)
@@ -21,5 +21,4 @@
 
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Optimization {
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IStochasticOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IStochasticOperator.cs	(revision 2864)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IStochasticOperator.cs	(revision 2865)
@@ -21,5 +21,4 @@
 
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Optimization {
Index: trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IStochasticSolutionCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IStochasticSolutionCreator.cs	(revision 2864)
+++ 	(revision )
@@ -1,30 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Optimization {
-  /// <summary>
-  /// An interface which represents an operator for creating new solutions.
-  /// </summary>
-  public interface IStochasticSolutionCreator : IStochasticOperator, ISolutionCreator { }
-}
Index: trunk/sources/HeuristicLab.Optimization/3.3/Problem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Problem.cs	(revision 2864)
+++ 	(revision )
@@ -1,113 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Drawing;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Parameters;
-using System;
-using HeuristicLab.Common;
-
-namespace HeuristicLab.Optimization {
-  /// <summary>
-  /// A base class for optimization problems.
-  /// </summary>
-  [Item("Problem", "A base class for optimization problems.")]
-  [EmptyStorableClass]
-  public abstract class Problem : ParameterizedNamedItem, IProblem {
-    public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Type; }
-    }
-
-    private IValueParameter<ISolutionCreator> SolutionCreatorParameter {
-      get { return (IValueParameter<ISolutionCreator>)Parameters["SolutionCreator"]; }
-    }
-    private IValueParameter<IEvaluator> EvaluatorParameter {
-      get { return (IValueParameter<IEvaluator>)Parameters["Evaluator"]; }
-    }
-    public ISolutionCreator SolutionCreator {
-      get { return SolutionCreatorParameter.Value; }
-      set { SolutionCreatorParameter.Value = value; }
-    }
-    public IEvaluator Evaluator {
-      get { return EvaluatorParameter.Value; }
-      set { EvaluatorParameter.Value = value; }
-    }
-    private OperatorSet operators;
-    public OperatorSet Operators {
-      get { return operators; }
-    }
-
-    protected Problem()
-      : base() {
-      AddParameters();
-    }
-    protected Problem(string name)
-      : base(name) {
-      AddParameters();
-    }
-    protected Problem(string name, ParameterCollection parameters)
-      : base(name, parameters) {
-      AddParameters();
-    }
-    protected Problem(string name, string description)
-      : base(name, description) {
-      AddParameters();
-    }
-    protected Problem(string name, string description, ParameterCollection parameters)
-      : base(name, description, parameters) {
-      AddParameters();
-    }
-
-    private void AddParameters() {
-      ValueParameter<ISolutionCreator> solutionCreatorParameter = new ValueParameter<ISolutionCreator>("SolutionCreator", "The operator which should be used to create new solutions.");
-      solutionCreatorParameter.ValueChanged += new EventHandler(SolutionCreatorParameter_ValueChanged);
-      Parameters.Add(solutionCreatorParameter);
-
-      ValueParameter<IEvaluator> evaluatorParameter = new ValueParameter<IEvaluator>("Evaluator", "The operator which should be used to evaluate solutions.");
-      evaluatorParameter.ValueChanged += new EventHandler(EvaluatorParameter_ValueChanged);
-      Parameters.Add(evaluatorParameter);
-    }
-
-    private void SolutionCreatorParameter_ValueChanged(object sender, EventArgs e) {
-      OnSolutionCreatorChanged();
-    }
-    private void EvaluatorParameter_ValueChanged(object sender, EventArgs e) {
-      OnEvaluatorChanged();
-    }
-
-    public event EventHandler SolutionCreatorChanged;
-    protected virtual void OnSolutionCreatorChanged() {
-      if (SolutionCreatorChanged != null)
-        SolutionCreatorChanged(this, EventArgs.Empty);
-    }
-    public event EventHandler EvaluatorChanged;
-    protected virtual void OnEvaluatorChanged() {
-      if (EvaluatorChanged != null)
-        EvaluatorChanged(this, EventArgs.Empty);
-    }
-    public event EventHandler<EventArgs<Type>> OperatorsChanged;
-    protected virtual void OnOperatorsChanged(Type operatorType) {
-      if (OperatorsChanged != null)
-        OperatorsChanged(this, new EventArgs<Type>(operatorType));
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.Optimization/3.3/SingleObjectiveEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/SingleObjectiveEvaluator.cs	(revision 2864)
+++ 	(revision )
@@ -1,44 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Optimization {
-  /// <summary>
-  /// A base class for evaluation operators for single-objective optimization problems.
-  /// </summary>
-  [Item("SingleObjectiveEvaluator", "A base class for evaluation operators for single-objective optimization problems.")]
-  [EmptyStorableClass]
-  public abstract class SingleObjectiveEvaluator : SingleSuccessorOperator, ISingleObjectiveEvaluator {
-    public ILookupParameter<DoubleData> QualityParameter {
-      get { return (ILookupParameter<DoubleData>)Parameters["Quality"]; }
-    }
-
-    protected SingleObjectiveEvaluator()
-      : base() {
-      Parameters.Add(new LookupParameter<DoubleData>("Quality", "The evaluated quality of the solution."));
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.Optimization/3.3/SingleObjectiveProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/SingleObjectiveProblem.cs	(revision 2864)
+++ 	(revision )
@@ -1,85 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Drawing;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Parameters;
-using HeuristicLab.Data;
-using System;
-
-namespace HeuristicLab.Optimization {
-  /// <summary>
-  /// A base class for single-objective optimization problems.
-  /// </summary>
-  [Item("SingleObjectiveProblem", "A base class for single-objective optimization problems.")]
-  [EmptyStorableClass]
-  public abstract class SingleObjectiveProblem : Problem, ISingleObjectiveProblem {
-    private ValueParameter<BoolData> MaximizationParameter {
-      get { return (ValueParameter<BoolData>)Parameters["Maximization"]; }
-    }
-    public BoolData Maximization {
-      get { return MaximizationParameter.Value; }
-      set { MaximizationParameter.Value = value; }
-    }
-    public new ISingleObjectiveEvaluator Evaluator {
-      get { return (ISingleObjectiveEvaluator)base.Evaluator; }
-      set { base.Evaluator = value; }
-    }
-
-    protected SingleObjectiveProblem()
-      : base() {
-      AddParameters();
-    }
-    protected SingleObjectiveProblem(string name)
-      : base(name) {
-      AddParameters();
-    }
-    protected SingleObjectiveProblem(string name, ParameterCollection parameters)
-      : base(name, parameters) {
-      AddParameters();
-    }
-    protected SingleObjectiveProblem(string name, string description)
-      : base(name, description) {
-      AddParameters();
-    }
-    protected SingleObjectiveProblem(string name, string description, ParameterCollection parameters)
-      : base(name, description, parameters) {
-      AddParameters();
-    }
-
-    private void AddParameters() {
-      ValueParameter<BoolData> maximizationParameter = new ValueParameter<BoolData>("Maximization", "True if the problem is a maximization problem, otherwise false.", new BoolData(true));
-      maximizationParameter.ValueChanged += new System.EventHandler(MaximizationParameter_ValueChanged);
-      Parameters.Add(maximizationParameter);
-    }
-
-    private void MaximizationParameter_ValueChanged(object sender, System.EventArgs e) {
-      OnMaximizationChanged();
-    }
-
-    public event EventHandler MaximizationChanged;
-    protected virtual void OnMaximizationChanged() {
-      if (MaximizationChanged != null)
-        MaximizationChanged(this, EventArgs.Empty);
-    }
-  }
-}