Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 2870)
@@ -160,6 +160,6 @@
       if (itemsListView.SelectedItems.Count == 1) {
         T item = itemsListView.SelectedItems[0].Tag as T;
+        detailsGroupBox.Enabled = true;
         viewHost.Content = item;
-        detailsGroupBox.Enabled = true;
       } else {
         viewHost.Content = null;
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 2870)
@@ -135,6 +135,6 @@
       if (itemsListView.SelectedItems.Count == 1) {
         T item = (T)itemsListView.SelectedItems[0].Tag;
+        detailsGroupBox.Enabled = true;
         viewHost.Content = item;
-        detailsGroupBox.Enabled = true;
       } else {
         viewHost.Content = null;
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 2870)
@@ -162,6 +162,6 @@
       if (itemsListView.SelectedItems.Count == 1) {
         T item = (T)itemsListView.SelectedItems[0].Tag;
+        detailsGroupBox.Enabled = true;
         viewHost.Content = item;
-        detailsGroupBox.Enabled = true;
       } else {
         viewHost.Content = null;
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemView.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/NamedItemView.cs	(revision 2870)
@@ -64,8 +64,6 @@
         Caption = "NamedItem";
         nameTextBox.Text = "-";
-        nameTextBox.ReadOnly = false;
         nameTextBox.Enabled = false;
         descriptionTextBox.Text = "";
-        nameTextBox.ReadOnly = false;
         descriptionTextBox.Enabled = false;
       } else {
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterizedNamedItemView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterizedNamedItemView.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterizedNamedItemView.cs	(revision 2870)
@@ -53,8 +53,6 @@
       if (Content == null) {
         parameterCollectionView.Content = null;
-        parameterCollectionView.Enabled = false;
       } else {
         parameterCollectionView.Content = Content.Parameters;
-        parameterCollectionView.Enabled = true;
       }
     }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs	(revision 2870)
@@ -33,10 +33,12 @@
       get { return this.viewType; }
       set {
-        if (value != null && !ViewCanShowContent(value, content))
-          throw new ArgumentException(string.Format("View \"{0}\" cannot display content \"{1}\".",
-                                                    value.GetPrettyName(),
-                                                    content.GetType().GetPrettyName()));
-        viewType = value;
-        UpdateView();
+        if (viewType != value) {
+          if (value != null && !ViewCanShowContent(value, content))
+            throw new ArgumentException(string.Format("View \"{0}\" cannot display content \"{1}\".",
+                                                      value.GetPrettyName(),
+                                                      content.GetType().GetPrettyName()));
+          viewType = value;
+          UpdateView();
+        }
       }
     }
@@ -62,13 +64,11 @@
 
     private void Initialize() {
-      viewsLabel.Enabled = false;
       viewsLabel.Visible = false;
       viewContextMenuStrip.Enabled = false;
       messageLabel.Visible = false;
 
+      viewPanel.Visible = false;
       if (viewPanel.Controls.Count > 0) viewPanel.Controls[0].Dispose();
       viewPanel.Controls.Clear();
-      viewPanel.Enabled = false;
-      viewPanel.Visible = false;
 
       if (Content != null) {
@@ -76,8 +76,6 @@
           messageLabel.Visible = true;
         } else {
-          viewsLabel.Enabled = true;
           viewsLabel.Visible = true;
           viewContextMenuStrip.Enabled = true;
-          messageLabel.Visible = false;
         }
 
@@ -99,14 +97,13 @@
 
       if (!ViewCanShowContent(viewType, content))
-        throw new ArgumentException(string.Format("View \"{0}\" cannot display content \"{1}\".",
-                                                  viewType.GetPrettyName(),
-                                                  Content.GetType().GetPrettyName()));
+        throw new InvalidOperationException(string.Format("View \"{0}\" cannot display content \"{1}\".",
+                                                          viewType.GetPrettyName(),
+                                                          Content.GetType().GetPrettyName()));
 
       UpdateActiveMenuItem();
       Control view = (Control)MainFormManager.CreateView(viewType, Content);
-      viewPanel.Controls.Add(view);
       viewPanel.Tag = view;
       view.Dock = DockStyle.Fill;
-      viewPanel.Enabled = true;
+      viewPanel.Controls.Add(view);
       viewPanel.Visible = true;
     }
Index: /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.Designer.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.Designer.cs	(revision 2870)
@@ -25,6 +25,13 @@
     /// </summary>
     private void InitializeComponent() {
-      components = new System.ComponentModel.Container();
+      this.SuspendLayout();
+      // 
+      // ContentView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Name = "ContentView";
+      this.ResumeLayout(false);
+
     }
 
Index: /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterView.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterView.cs	(revision 2870)
@@ -91,7 +91,7 @@
       if (Content == null) {
         Caption = "ConstrainedValueParameter";
+        viewHost.Content = null;
         valueGroupBox.Enabled = false;
         FillValueComboBox();
-        viewHost.Content = null;
       } else {
         Caption = Content.Name + " (" + Content.GetType().Name + ")";
Index: /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueParameterView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueParameterView.cs	(revision 2869)
+++ /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueParameterView.cs	(revision 2870)
@@ -86,6 +86,6 @@
         setValueButton.Enabled = false;
         clearValueButton.Enabled = false;
+        viewHost.Content = null;
         valueGroupBox.Enabled = false;
-        viewHost.Content = null;
       } else {
         Caption = Content.Name + " (" + Content.GetType().Name + ")";